const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property
    useCaption: boolean = false;

    @property(cc.ScrollView)
    scrollView:cc.ScrollView = null;

    onLoad () {
        this.loadResPrefab(`SpriteA`).then(prefab=>{
            let node = <cc.Node>cc.instantiate(prefab);
            this.scrollView.content.addChild(node);
            this.scrollView.content.setContentSize(cc.size(node.width,node.height));
        });

        this.node.on(cc.Node.EventType.TOUCH_START,this.onClick,this);
    }

    onClick(event) {
        cc.log(`touchevent:`,this.node.name);
    }

    onScroll() {
        cc.log("scroll");
    }

    loadResPrefab(path) {
        return new Promise((resolve,reject)=>{
            cc.loader.loadRes(path,(err, prefabClass)=>{
                if (err) {
                    cc.error(err);
                    reject(err);
                }else {
                    resolve(prefabClass);
                }
            });
        });
    }
}
